<?php
/*
Plugin Name: Default avatars
Plugin URI: http://marksw.com/wordpress/
Description: Set the type of avatar to apear when the commenter do not have a configured avatar
Author: Mark Kaplun
Version: 0.9
Author URI: http://marksw.com/wordpress/
*/

function mkav_get_avatar($url, $id_or_email, $size, $default) {
    $type=get_option('mkav_default_avatar_type');
    if ($type && $type!='none')
      $url= preg_replace("/src='(\S+)'/","src='$1&default=$type'",$url);
    return $url;
}

function mkav_add_settings_page() {
    if (get_option('show_avatars')) {
        load_plugin_textdomain('defaultavatars', 'wp-content/plugins/defaultavatars');
	    add_submenu_page('options-general.php', __('Default avatar type','defaultavatars'), __('Default avatar type','defaultavatars'), 10, basename(__FILE__), 'mkav_config_page');
	}
}

function mkav_config_page() {
    if (isset($_POST['default_avatar_type'])) {
        update_option('mkav_default_avatar_type',$_POST['default_avatar_type']);
    }
?>
<div class="wrap">
  <h2>
    <?php _e('Default avatar type','defaultavatars')?>
  </h2>
  <form name="form" method="post">
  <div>
  <?php _e('For comenters non not having an avatar use','defaultavatars')?>&nbsp;
  <select name="default_avatar_type" id="default_avatar_type">
  <?php
    $avtype = get_option('mkav_default_avatar_type');
    if (!$avtype) {
        $avtype = 'none';
    }
    $avtypes = array('none' => __("None",'defaultavatars'), 
                     'wavatar' => __('Wavatars','defaultavatars'),
                     'monsterid' => __('Monsters','defaultavatars'),
                     'identicon' => __('Geometric shapes','defaultavatars')
                     );
    foreach ( $avtypes as $key => $value) {
	    $selected = ($avtype == $key) ? 'selected="selected"' : '';
	    echo "\n\t<option value='$key' $selected>$value</option>";
    }
  ?>
  </select>
  </div>  
  <input type="submit" name="Submit" value="<?php _e('Save Changes') ?>" />
  </form>
</div>  
<?
}

add_filter('get_avatar', 'mkav_get_avatar',10,4);
add_action('admin_menu', 'mkav_add_settings_page');

?>